/*       Name:  PTVerbs.ch
       Author:  Steve Straley
       Notice:  Copyright(c) 1991-1993  - Sirius Software Development, Inc.
                All Rights Reserved     - 415-399-9810
         Date:  July 3, 1993
      Compile:  N/A
      Version:  Clipper 5.01
 Include Path:  \PTools\Include
  Environment:  f051;
         Link:  N/A
 Library Path:  \Clipper\501
         Note:  This is the header file for the Clipper Power Tools
                Library for all of the commands

//% 001 sjs Added new preprocessor directive to state the versions of
            this header file.
//% 002 sjs Added the STARTING AT clause for the READ command that is
            now supported in the READMODAL() function.
//% 003 sjs Make a conditional compiling directive in case someone wants
            to use Clipper's WAIT and SET KEY definitions and not the
            Power Tools.

*/

#stdout Using PTVerbs.ch - version 2.0a

//% 001 sjs Added new commands to the standard 1.0 release

#xtranslate VOID => return( NIL )

#xcommand PROCESS => while .T.
#xcommand END PROCESS => end

#xcommand REPEAT => while .t.
#xcommand UNTIL <exp> => if <exp> ; exit ; end ; end

#xcommand DEFAULT REGISTERS => aRegister := array(10)

#xcommand DO SWITCH => do case
#xcommand SWITCH <exp> [ PERFORM <act> ] => case <exp> [; <act>]
#xcommand END SWITCH => endcase

#xcommand SAVE GET TO <var>      => ;
         <var> := aclone( getlist ) ; getlist := {}
#xcommand RESTORE GET FROM <var> => getlist := <var>

#xtranslate (<var> IS <type>)      =>  ( valtype(<var>) = <type> )
#xtranslate (<var> IS NOT <type>)  =>  ( valtype(<var>) != <type> )

#xcommand IF <var> IS <type>          => if valtype(<var>) = <type>
#xcommand IF <var> IS NOT <type>      => if valtype(<var>) != <type>
#xcommand IF <ele> IS IN <array>      => if !(len( <array> ) \< <ele> )
#xcommand IF <ele> IS NOT IN <array>  => if len( <array> ) \< <ele>

#xtranslate @@<exp>      => {|x| if( x == nil, <exp>, <exp> := x)}
#xtranslate (<x> !$ <y>) => !( <x> $ <y> )

//% 003 sjs Make a conditional compiling directive

#ifndef CLIPPER
        #xcommand WAITKEY [<c>]                           => WaitKey( <c>, .t. )
        #xcommand WAITKEY  [<c>] TO <var>                 => WaitKey( <c>, .t.,,, @<var>, <(var)> )
        #xcommand WAITKEY  AT <row>, <col> [<c>]          => WaitKey( <c>, .t.,<row>, <col> )
        #xcommand WAITKEY  AT <row>, <col> [<c>] TO <var> => WaitKey( <c>, .t.,<row>, <col>, @<var>, <(var)> )

        #xcommand SET KEY <n> TO <proc>                  [DESCRIPT <name>]        => SETKEYTABLE( <n>, {|p,l,v,oGet,aList,nPos| <proc>(p,l,v,oGet,aList,nPos)}, <name> )
        #xcommand SET KEY <n> TO <proc>( [<list,...>] )  [DESCRIPT <name>]        => SETKEYTABLE( <n>, {|| <proc>(<list>) }, <name> )
        #xcommand SET KEY <n> [TO]                               => SETKEYTABLE( <n>, NIL )
        #xcommand SET KEY RESET                                  => SETKEYTABLE(,,,.t.)
        #xcommand SET KEY <n> TO BLOCK <block> [DESCRIPT <name>] => SETKEYTABLE( <n>, <block>, <name> )
        #xcommand SET KEY STACK TO <var>                         => <var> := SETKEYTABLE()
        #xcommand SET KEY STACK FROM <var>                       => SETKEYTABLE(,,,,<var>)
#endif

#xcommand INIT MASTER         => local lMaster
#xcommand BEGIN MASTER        => begin sequence
#xcommand EXIT MASTER         => lMaster := .t.
#xcommand END MASTER          => end; if lMaster != NIL ; exit ; end
#xcommand SET MASTER TO <key> => setkey( <key>, {|| Break(NIL)}, "Return to master key" )

#xcommand DEFAULT <exp> TO <value> [, <expN> TO <valN> ] => ;
          <exp> := if(( valtype(<exp>)==valtype(<value>) .and. (<exp> != nil)), <exp>, <value>) ;
          [; <expN> := if(( valtype(<expN>)==valtype(<valN>) .and. (<expN> != nil)), <expN>, <valN>) ]

#xtranslate NEWREADER <exp> [WITH <var>] => ;
            send reader := {|x| <exp>(x [,<var>])}

#xcommand INIT DATA <exp> => <exp> := { {}, {}, {|| NIL}, {|| NIL} }

#xcommand INIT DATA <exp> PRE <block> => ;
                    <exp> := { {}, {}, <block>, {|| NIL} }

#xcommand INIT DATA <exp> POST <block> => ;
                    <exp> := { {}, {}, {|| NIL}, <block> }

#xcommand INIT DATA <exp> PRE <block1> POST <block2> => ;
                    <exp> := { {}, {}, <block1>, <block2> }


#xcommand DEFINE DATA <array> GET <get> ;
                 AT <row>, <col> ;
                 [COLOR <color>] ;
                 [PICT <pict>] ;
                 [MESSAGE <message> [MSGCOLOR <newcolor>][AT <mRow>, <mCol>] ] ;
                 [KEYSET <key> [TO <block>] [<offkey: ONLY>]] ;
                 [READER <reader> ] ;
                 [WHEN <when>] ;
                 [VALID <valid>] => ;
                                    ;
  BuildGetSystem(<array>, , ;
    {<get>, {|a| if(a=nil, <get>, <get>:=a)}, <(get)>, ;
            <row>, ;
            <col>, ;
            <color>, ;
            <pict>, ;
            <message>, ;
            <newcolor>, ;
            <mRow>, ;
            <mCol>, ;
            <reader>, ;
            <key>, ;
            <block>, ;
            <.offkey.>, ;
            <{when}>, ;
            <{valid}> } )

#xcommand DEFINE DATA <array> SAY <say> ;
                 AT <row>, <col> ;
                 [PICT <pict>] [COLOR <color>] ;
                 [GET <get> [AT <gRow>, <gCol>] ;
                 [COLOR <gColor>] ;
                 [PICT <gPict>] ;
                 [MESSAGE <message> [MSGCOLOR <newcolor>][AT <mRow>, <mCol>] ] ;
                 [KEYSET <key> [TO <block>][<offkey: ONLY>]] ;
                 [READER <reader> ] ;
                 [WHEN <when>] ;
                 [VALID <valid>] ] => ;
                                      ;
   BuildGetSystem( <array>, ;
              {<row>, <col>, <say>, <pict>, <color>, ;
               {|cPict, cColor| setpos(<row>, <col>), ;
                 if(cPict == NIL, ;
                    devout(<say>, <color> ), ;
                    devoutpict( <say>, cPict, <color> ) ;
                                          ) ;
                       } } ;
             [, {<get>, ;
                {|a| if(a=nil, <get>, <get>:=a)}, ;
                <(get)>, ;
                <gRow>, ;
                <gCol>, ;
                <gColor>, ;
                <gPict>, ;
                <message>, ;
                <newcolor>, ;
                <mRow>, ;
                <mCol>,;
                <reader>, ;
                <key>, ;
                <block>, ;
                <.offkey.>, ;
                <{when}>, ;
                <{valid}> } ] )

#xcommand BUILD VIEWER TO <var> [COLOR <color,...>] => ;
          <var> := { { {}, {,}, {,},<(var)>,#<color>,,}, {}, {}, {}, {}, {}, {} }

#xcommand VIEW <var> NAME <name> => <var>\[1,4] := <"name">

#xcommand VIEW <var> SAVE FILE <name> => ;
          <var>\[1,7] := <name>

#xcommand VIEW <var> AT <top>, <left>, <bottom>, <right> => ;
          <var>\[1,1] := {<top>, <left>, <bottom>, <right>}

#xcommand VIEW RELATION <key> INTO <alias> TO <var> => ;
          <var>\[1,2,1] := {|lBefore| if( lBefore, ;
                                (dbClearRel(), ;
                                 dbSetRelation( <(alias)>, <{key}>, <"key">)), ;
                                 dbClearRel() ) } ;;
          <var>\[1,2,2] := "{ '"+ <(alias)> + "', {|| " + <(key)> + "}, '" + <"key"> + "'}"

#xcommand VIEW ITEM <header>, <thing> [WIDTH <width>] [SEARCH <block>] IN <var> => ;
          aadd(<var>\[2], <header>) ;;
          aadd(<var>\[3], <thing>) ;;
          aadd(<var>\[4], <width>) ;;
          aadd(<var>\[5], <"thing"> ) ;;
          aadd(<var>\[6], <block> ) ;;
          aadd(<var>\[7], <"block"> )

#xcommand VIEW <var> [WITH <block>][DISPLAY <aDisp>] => ;
           ViewModal(<var> [, {|nKey, oView, aData| <block>(nKey, oView, aData)}][, <aDisp>] )

#xcommand VIEW <var> TO <item> [WITH <block>][DISPLAY <aDisp>] => ;
           <item> := ViewModal(<var> [, {|nKey, oView, aData| <block>(nKey, oView, aData)}][, <aDisp>])

#xcommand VIEW <var> [EXCEPTION <block>] [DISPLAY <aDisp>] => ;
           ViewModal(<var> [, <{block}> ][, <aDisp>] )

#xcommand VIEW <var> TO <item> [EXCEPTION <block>][DISPLAY <aDisp>] => ;
           <item> := ViewModal(<var> [, <{block}> ][, <aDisp>])

//% 001 These are the items to be released in Version 1.1

#xcommand for <x> := <nStart> up to <nEnd> [step <value>] => ;
          for <x> := <nStart> to <nEnd> [step <value>]

#xcommand FOR <x> := <nStart> DOWN TO <nEnd> STEP <value> => ;
          for <x> := <nStart> to <nEnd> step (-1 * <value>)

#xcommand FOR <x> := <nStart> DOWN TO <nEnd> => ;
          for <x> := <nStart> to <nEnd> step -1

#xcommand FOR <x> = <*rest*> => for <x> := <rest>

#xcommand @ <row>, <col> [SAY <xpr> [PICTURE <pic>] [COLOR <color>]]  ;
      => DevPos( <row>, <col> )                                    ;
       [; DevOutPict( <xpr>, <pic>, <color> )]

#xcommand @ <row>, <col> [ SAY <exp> [COLOR <color>] ] => ;
          devpos( <row>, <col> ) ;
          [; devout( <exp>, <color> ) ]

#xcommand local <exp,...> as int     => local <exp>
#xcommand local <exp,...> as char    => local <exp>
#xcommand local <exp,...> as double  => local <exp>
#xcommand local <exp,...> as date    => local <exp>
#xcommand local <exp,...> as logical => local <exp>
#xcommand local <exp,...> as float   => local <exp>
#xcommand local <exp,...> as array   => local <exp>
#xcommand local <exp,...> as block   => local <exp>
#xcommand local <exp,...> as object  => local <exp>
#xcommand local <exp,...> as usual   => local <exp>

#xcommand static <exp,...> as int     => static <exp>
#xcommand static <exp,...> as char    => static <exp>
#xcommand static <exp,...> as double  => static <exp>
#xcommand static <exp,...> as date    => static <exp>
#xcommand static <exp,...> as logical => static <exp>
#xcommand static <exp,...> as float   => static <exp>
#xcommand static <exp,...> as array   => static <exp>
#xcommand static <exp,...> as block   => static <exp>
#xcommand static <exp,...> as object  => static <exp>
#xcommand static <exp,...> as usual   => static <exp>

#xcommand private <exp,...> as int     => private <exp>
#xcommand private <exp,...> as char    => private <exp>
#xcommand private <exp,...> as double  => private <exp>
#xcommand private <exp,...> as date    => private <exp>
#xcommand private <exp,...> as logical => private <exp>
#xcommand private <exp,...> as float   => private <exp>
#xcommand private <exp,...> as array   => private <exp>
#xcommand private <exp,...> as block   => private <exp>
#xcommand private <exp,...> as object  => private <exp>
#xcommand private <exp,...> as usual   => private <exp>

#xcommand public <exp,...> as int    => public <exp>
#xcommand public <exp,...> as char   => public <exp>
#xcommand public <exp,...> as double => public <exp>
#xcommand public <exp,...> as date   => public <exp>
#xcommand public <exp,...> as logical=> public <exp>
#xcommand public <exp,...> as float  => public <exp>
#xcommand public <exp,...> as array  => public <exp>
#xcommand public <exp,...> as block  => public <exp>
#xcommand public <exp,...> as object => public <exp>
#xcommand public <exp,...> as usual  => public <exp>

#xcommand global <exp,...> => public <*exp*>
#xcommand memvar <exp,...> as <*stuff*> => memvar <exp>

#xcommand SET <var> WITHIN <bottom> TO <top> BASE <value> => ;
          if !(<var> >= <bottom> .and. <var> <= <top> ) ;;
            <var> := <value> ;;
          endif

#ifndef CLIPPER

#xcommand REPLACE [ <f1> WITH <x1> [, <fn> WITH <xn>] ] [FOR <for>] ;
          [WHILE <while>] [NEXT <next>] [RECORD <rec>] [<rest:REST>] ;
          [<stay: STAY PUT>] [ALL] => ;
  DBNetEval( {|| _FIELD-><f1> := <x1> [, _FIELD-><fn> := <xn>]}, ;
             <{for}>, <{while}>, <next>, <rec>, <.rest.>, <.stay.> )


#xcommand REPLACE <f1> WITH <v1> [, <fN> WITH <vN> ]  => ;
  _FIELD-><f1> := <v1> [; _FIELD-><fN> := <vN>]

#xcommand COUNT [TO <var>] [FOR <for>] [WHILE <while>] [NEXT <next>] ;
          [RECORD <rec>] [<rest:REST>] [<stay:STAY PUT>] [ALL] =>    ;
  <var> := 0 ;;
  DBNetEval( {|| <var> := <var> + 1}, ;
            <{for}>, <{while}>, <next>, <rec>, <.rest.>, <.stay.>)

#xcommand SUM [ <x1> [, <xn>]  TO  <v1> [, <vn>] ] [FOR <for>] ;
          [WHILE <while>] [NEXT <next>] [RECORD <rec>] [<rest:REST>] ;
          [<stay:STAY PUT>] [ALL] => ;
  <v1> := [ <vn> := ] 0 ;;
  DBNetEval( {|| <v1> := <v1> + <x1> [, <vn> := <vn> + <xn> ]}, ;
             <{for}>, <{while}>, <next>, <rec>, <.rest.>, <.stay.> )

#xcommand AVERAGE [ <x1> [, <xn>]  TO  <v1> [, <vn>] ] [FOR <for>] ;
          [WHILE <while>] [NEXT <next>] [RECORD <rec>] [<rest:REST>] ;
          [<stay:STAY PUT>] [ALL] => ;
  M->__Avg := <v1> := [ <vn> := ] 0 ;;
  DBNetEval( {|| M->__Avg := M->__Avg + 1, ;
             <v1> := <v1> + <x1> [, <vn> := <vn> + <xn>] }, ;
             <{for}>, <{while}>, <next>, <rec>, <.rest.>, <.stay.> ) ;;
  <v1> := <v1> / M->__Avg [; <vn> := <vn> / M->__Avg ]


#xcommand DELETE [FOR <for>] [WHILE <while>] [NEXT <next>] [RECORD <rec>] ;
          [<rest:REST>] [<stay:STAY PUT>] [ALL] =>  ;
  DBNetEval( {|| dbDelete()}, ;
             <{for}>, <{while}>, <next>, <rec>, <.rest.>, <.stay.> )

#xcommand RECALL [FOR <for>] [WHILE <while>] [NEXT <next>] [RECORD <rec>] ;
          [<rest:REST>] [<stay:STAY PUT>] [ALL] =>  ;
  DBNetEval( {|| dbRecall()}, ;
             <{for}>, <{while}>, <next>, <rec>, <.rest.>, <.stay.> )

#xcommand DELETE                 =>  dbDelete()
#xcommand RECALL                 =>  dbRecall()

#endif

//% 002 sjs Adding the STARTING AT command for the READ clause

#ifndef CLIPPER

#xcommand READ [STARTING AT <get>] => ;
          PTReadModal( getlist, <get> ) ;;
          getlist := {}

#else

#xcommand READ [STARTING AT <get>] => ;
          ReadModal( getlist, <get> ) ;;
          getlist := {}

#endif
// End of File: PTVerbs.ch
